gtkmm: Gdk::Visual Class Reference

gtkmm 3.91.0

- Main Page
- Related Pages
- Modules
- Namespaces
- Classes

- Class List
- Class Index
- Class Hierarchy
- Class Members

Public Types | Public Member Functions | Static Public Member Functions | Protected Member Functions | Related Functions | List of all members
Gdk::Visual Class Reference

A Gdk::Visual describes a particular video hardware display format. More...

`#include <gdkmm/visual.h>`

Inheritance diagram for Gdk::Visual:
[legend]

## Public Types
enum | Type { Type::STATIC_GRAY, Type::GRAYSCALE, Type::STATIC_COLOR, Type::PSEUDO_COLOR, Type::TRUE_COLOR, Type::DIRECT_COLOR }
| A set of values that describe the manner in which the pixel values for a visual are converted into RGB values for display. More...
Public Types inherited from Glib::Object
typedef void(*)(gpointer data | DestroyNotify)
Public Types inherited from sigc::trackable
typedef internal::func_destroy_notify | func_destroy_notify

## Public Member Functions
| Visual (Visual&& src) noexcept
Visual& | operator= (Visual&& src) noexcept
| ~Visual () noexceptoverride
GdkVisual* | gobj ()
| Provides access to the underlying C GObject. More...
const GdkVisual* | gobj () const
| Provides access to the underlying C GObject. More...
GdkVisual* | gobj_copy ()
| Provides access to the underlying C instance. The caller is responsible for unrefing it. Use when directly setting fields in structs. More...
Glib::RefPtr< Screen > | get_screen ()
| Gets the screen to which this visual belongs. More...
Glib::RefPtr< const Screen > | get_screen () const
| Gets the screen to which this visual belongs. More...
Type | get_visual_type () const
| Returns the type of visual this is (PseudoColor, TrueColor, etc). More...
int | get_depth () const
| Returns the bit depth of this visual. More...
void | get_red_pixel_details (guint32& mask, int&shift, int& precision) const
| Obtains values that are needed to calculate red pixel values in TrueColor and DirectColor. More...
void | get_green_pixel_details (guint32& mask, int&shift, int& precision) const
| Obtains values that are needed to calculate green pixel values in TrueColor and DirectColor. More...
void | get_blue_pixel_details (guint32& mask, int&shift, int& precision) const
| Obtains values that are needed to calculate blue pixel values in TrueColor and DirectColor. More...
Public Member Functions inherited from Glib::Object
| Object (const Object &)=delete
Object & | operator= (const Object &)=delete
| Object (Object &&src) noexcept
Object & | operator= (Object &&src) noexcept
void * | get_data (const QueryQuark &key)
void | set_data (const Quark &key, void *data)
void | set_data (const Quark &key, void *data, DestroyNotify notify)
void | remove_data (const QueryQuark &quark)
void * | steal_data (const QueryQuark &quark)
Glib::RefPtr< Glib::Object > | wrap (GObject *object, bool take_copy=false)
Public Member Functions inherited from Glib::ObjectBase
| ObjectBase (const ObjectBase &)=delete
ObjectBase & | operator= (const ObjectBase &)=delete
void | set_property_value (const Glib::ustring &property_name, const Glib::ValueBase &value)
void | get_property_value (const Glib::ustring &property_name, Glib::ValueBase &value) const
void | set_property (const Glib::ustring &property_name, const PropertyType &value)
void | get_property (const Glib::ustring &property_name, PropertyType &value) const
PropertyType | get_property (const Glib::ustring &property_name) const
sigc::connection | connect_property_changed (const Glib::ustring &property_name, const sigc::slot< void()> &slot)
sigc::connection | connect_property_changed (const Glib::ustring &property_name, sigc::slot< void()> &&slot)
void | freeze_notify ()
void | thaw_notify ()
virtual void | reference () const
virtual void | unreference () const
GObject * | gobj ()
const GObject * | gobj () const
GObject * | gobj_copy () const
Public Member Functions inherited from sigc::trackable
| trackable () noexcept
| trackable (const trackable &src) noexcept
| trackable (trackable &&src)
| ~trackable ()
void | add_destroy_notify_callback (void *data, func_destroy_notify func) const
void | notify_callbacks ()
trackable & | operator= (const trackable &src)
trackable & | operator= (trackable &&src)
void | remove_destroy_notify_callback (void *data) const

## Static Public Member Functions
static GType | get_type ()
| Get the GType for this class, for use with the underlying GObject type system. More...

## Protected Member Functions
| Visual ()
Protected Member Functions inherited from Glib::Object
| Object ()
| Object (const Glib::ConstructParams &construct_params)
| Object (GObject *castitem)
| ~Object () noexceptoverride
Protected Member Functions inherited from Glib::ObjectBase
| ObjectBase ()
| ObjectBase (const char *custom_type_name)
| ObjectBase (const std::type_info &custom_type_info)
| ObjectBase (ObjectBase &&src) noexcept
ObjectBase & | operator= (ObjectBase &&src) noexcept
virtual | ~ObjectBase () noexcept=0
void | initialize (GObject *castitem)
void | initialize_move (GObject *castitem, Glib::ObjectBase *previous_wrapper)

## Related Functions
(Note that these are not member functions.)
Glib::RefPtr< Gdk::Visual > | wrap (GdkVisual* object, bool take_copy=false)
| A Glib::wrap() method for this object. More...

## Detailed Description

A Gdk::Visual describes a particular video hardware display format.

It includes information about the number of bits used for each color, the way the bits are translated into an RGB value for display, and the way the bits are stored in memory. For example, a piece of display hardware might support 24-bit color, 16-bit color, or 8-bit color; meaning 24/16/8-bit pixel sizes. For a given pixel size, pixels can be in different formats; for example the "red" element of an RGB pixel may be in the top 8 bits of the pixel, or may be in the lower 4 bits.

There are several standard visuals. The visual returned by Gdk::Screen::get_system_visual() is the system's default visual.

A number of methods are provided for determining the "best" available visual. For the purposes of making this determination, higher bit depths are considered better, and for visuals of the same bit depth, GDK_VISUAL_PSEUDO_COLOR is preferred at 8bpp, otherwise, the visual types are ranked in the order of (highest to lowest) GDK_VISUAL_DIRECT_COLOR, GDK_VISUAL_TRUE_COLOR, GDK_VISUAL_PSEUDO_COLOR, GDK_VISUAL_STATIC_COLOR, GDK_VISUAL_GRAYSCALE, then GDK_VISUAL_STATIC_GRAY.

## Constructor & Destructor Documentation

Gdk::Visual::Visual | ( | Visual&& | src | ) |
| noexcept

Gdk::Visual::~Visual | ( |  | ) |
| overridenoexcept

Gdk::Visual::Visual | ( |  | ) |
| protected

## Member Function Documentation

void Gdk::Visual::get_blue_pixel_details | ( | guint32 & | mask,
|  | int & | shift,
|  | int & | precision
| ) |  | const

Obtains values that are needed to calculate blue pixel values in TrueColor and DirectColor.

The “mask” is the significant bits within the pixel. The “shift” is the number of bits left we must shift a primary for it to be in position (according to the "mask"). Finally, "precision" refers to how much precision the pixel value contains for a particular primary.

Since gtkmm 2.22:

Parameters

  mask | A pointer to a #guint32 to be filled in, or `nullptr`.
  shift | A pointer to a `int` to be filled in, or `nullptr`.
  precision | A pointer to a `int` to be filled in, or `nullptr`.

int Gdk::Visual::get_depth | ( |  | ) | const

Returns the bit depth of this visual.

Since gtkmm 2.22:

Returns
  The bit depth of this visual.

void Gdk::Visual::get_green_pixel_details | ( | guint32 & | mask,
|  | int & | shift,
|  | int & | precision
| ) |  | const

Obtains values that are needed to calculate green pixel values in TrueColor and DirectColor.

The “mask” is the significant bits within the pixel. The “shift” is the number of bits left we must shift a primary for it to be in position (according to the "mask"). Finally, "precision" refers to how much precision the pixel value contains for a particular primary.

Since gtkmm 2.22:

Parameters

  mask | A pointer to a #guint32 to be filled in, or `nullptr`.
  shift | A pointer to a `int` to be filled in, or `nullptr`.
  precision | A pointer to a `int` to be filled in, or `nullptr`.

void Gdk::Visual::get_red_pixel_details | ( | guint32 & | mask,
|  | int & | shift,
|  | int & | precision
| ) |  | const

Obtains values that are needed to calculate red pixel values in TrueColor and DirectColor.

The “mask” is the significant bits within the pixel. The “shift” is the number of bits left we must shift a primary for it to be in position (according to the "mask"). Finally, "precision" refers to how much precision the pixel value contains for a particular primary.

Since gtkmm 2.22:

Parameters

  mask | A pointer to a #guint32 to be filled in, or `nullptr`.
  shift | A pointer to a `int` to be filled in, or `nullptr`.
  precision | A pointer to a `int` to be filled in, or `nullptr`.

Glib::RefPtr<Screen> Gdk::Visual::get_screen | ( |  | ) |

Gets the screen to which this visual belongs.

Since gtkmm 2.2:

Returns
  The screen to which this visual belongs.

Glib::RefPtr<const Screen> Gdk::Visual::get_screen | ( |  | ) | const

Gets the screen to which this visual belongs.

Since gtkmm 2.2:

Returns
  The screen to which this visual belongs.

static GType Gdk::Visual::get_type | ( |  | ) |
| static

Get the GType for this class, for use with the underlying GObject type system.

Type Gdk::Visual::get_visual_type | ( |  | ) | const

Returns the type of visual this is (PseudoColor, TrueColor, etc).

Since gtkmm 2.22:

Returns
  A Gdk::Visual::Type stating the type of visual.

GdkVisual* Gdk::Visual::gobj | ( |  | ) |
| inline

Provides access to the underlying C GObject.

const GdkVisual* Gdk::Visual::gobj | ( |  | ) | const
| inline

Provides access to the underlying C GObject.

GdkVisual* Gdk::Visual::gobj_copy | ( |  | ) |

Provides access to the underlying C instance. The caller is responsible for unrefing it. Use when directly setting fields in structs.

Visual& Gdk::Visual::operator= | ( | Visual&& | src | ) |
| noexcept

## Friends And Related Function Documentation

Glib::RefPtr< Gdk::Visual > wrap | ( | GdkVisual * | object,
|  | bool | take_copy = `false`
| ) |  |
| related

A Glib::wrap() method for this object.

Parameters

  object | The C instance.
  take_copy | False if the result should take ownership of the C instance. True if it should take a new copy or ref.

Returns
  A C++ instance that wraps this C instance.